<template>
  <div class="form-content">
    <p>Экспертным тарифом называется тариф, предложенный экспертом в качестве образцового. Однако эксперты не в состоянии регулярно корректировать тарифы в зависимости от сезонных колебаний и прочих внешних обстоятельств. Для этого в системе предусмотрены способы регулярного автоматического дисконтирования экспертных тарифов по формуле:</p>
    <formula :items="EXPERT_RATE_FORMULA" />
    <div>
      <h2
        class="section-title mb-20"
      >Инфляционный и календарные коэффициенты на текущий календарный год</h2>
      <div class="row middle-xs">
        <div class="col-symbol">
          <div class="box symbol-box">
            К
            <sub>инфл.</sub>
          </div>
        </div>
        <div class="col-input">
          <div class="box-input">
            <ob-input
              type="money:3"
              class="delta-percent"
              sub-title="%"
              :value="model.inflation_rate"
              @input="onInputInflationRate"
              :is-convert-money="false"
            />
          </div>
        </div>
        <div class="col-tip">
          <div class="box">
            Процент инфляционного удорожания, полученный путем
            соотнесения цены 52 недели к цене 1 недели
          </div>
        </div>
      </div>
      <div class="row middle-xs">
        <div class="col-symbol">
          <div class="box symbol-box">
            К
            <sub>календ. w</sub>
          </div>
        </div>
        <div class="col-tip">
          <div
            class="box"
          >Календарный коэффициент указывается в профиле сезонности для каждой из 52 недель года. См. таблицу профиля сезонности:</div>
        </div>
      </div>

      <div class="expert-calendar-tips">
        <div class="season season-winter">Зима</div>
        <div class="season season-spring">Весна</div>
        <div class="season season-summer">Лето</div>
        <div class="season season-autumn">Осень</div>
      </div>

      <calendar-seasons />
    </div>
  </div>
</template>

<script>
import ObInput from 'common-components/src/obComponents/obInput';
import formula from '../../../../basePricesPage/components/StaticFormula';
import CalendarSeasons from './Calendar';

const EXPERT_RATE_FORMULA = [
  {
    label: 'T',
    index: 'эксп.',
    tipAbove: '',
    tipBelow: 'экспертный тариф',
    tipPositionClass: 'align-right',
    tipSizeClass: 'narrow',
  },
  {
    label: '=',
    index: '',
    tipAbove: '',
    tipBelow: '',
    isOperator: true,
  },
  {
    label: 'T',
    index: 'эксп.0',
    tipAbove: 'тариф, непосредственно указанный экспертом',
    tipBelow: '',
    tipPositionClass: 'align-right',
    tipSizeClass: 'mid',
  },
  {
    label: 'K',
    index: 'календ. W',
    tipAbove: '',
    tipBelow: 'Календарный коэффициент',
    tipPositionClass: 'align-left',
    tipSizeClass: 'narrow',
  },
  {
    label: '( 100%',
    index: '',
    tipAbove: '',
    tipBelow: '',
    isOperator: true,
  },
  {
    label: '+',
    index: '',
    tipAbove: '',
    tipBelow: '',
    isOperator: true,
  },
  {
    label: 'W',
    index: '',
    tipAbove: 'номер недели после ввода экспертного тарифа',
    tipBelow: '',
    tipPositionClass: 'align-right',
    tipSizeClass: 'mid',
  },
  {
    label: 'K',
    index: 'инфл.',
    tipAbove: 'годовая инфляциия',
    tipBelow: '',
    tipPositionClass: 'align-left',
    tipSizeClass: 'narrow',
  },
  {
    label: '/ 52 )',
    index: '',
    tipAbove: '',
    tipBelow: '',
    isOperator: true,
  },
];

export default {
  name: 'ExpertRateTab',
  components: {
    ObInput,
    formula,
    CalendarSeasons,
  },
  data() {
    return {
      EXPERT_RATE_FORMULA,
    };
  },
  computed: {
    ...mapGetters({
      model: 'base_prices/mathModel',
    }),
  },
  methods: {
    ...mapActions({
      setMathModelStatusField: 'base_prices/setMathModelStatusField',
      setMathModelField: 'base_prices/setMathModelField',
    }),
    onInputInflationRate(value) {
      this.setMathModelField({
        name: 'inflation_rate',
        value,
      });
    },
  },
};
</script>

<style lang="scss" scoped>
$cobalt-black: #191e32;
$shale-gray: #474b5b;
$gray-slate: #737682;

@import '../../../../../../node_modules/common-components/src/static/css/mixins';

::v-deep {
  .formula-block__element__top-tip__body.align-left.narrow {
    left: 30px;
  }
}

.section-title {
  @include font-mixin(16px, 20px, bold, $cobalt-black, 0.4px);

  padding-top: 20px;
  margin-bottom: 20px;
  + p {
    margin: 0 0 20px;
  }
}

.symbol-box {
  @include font-mixin(32px, 37px, 400, $shale-gray, 0.2px);
  text-align: left;
  sub {
    font-size: 12px;
    text-transform: uppercase;
    margin-left: -8px;
  }
  .units {
    align-self: center;
  }
}

.col {
  &-symbol {
    width: 95px;
    margin-right: 20px;
  }
  &-input {
    width: 110px;
    margin-right: 20px;
  }
  &-tip {
    flex: 1;
    color: #737682;
    font-size: 12px;
  }
}

.expert-calendar-tips {
  display: flex;
  justify-content: center;
  margin: 30px auto;
  .season {
    @include font-mixin(12px, 14px, 400, $cobalt-black, 0.4px);
    text-transform: uppercase;
    margin: 0 19px;
    &:before {
      content: "";
      width: 8px;
      height: 8px;
      display: inline-block;
      margin-right: 8px;
    }
  }
  .season-winter:before {
    background: #d6e2f6;
  }
  .season-spring:before {
    background: #ffeb48;
    opacity: 0.6;
  }
  .season-summer:before {
    background: #10cf96;
    opacity: 0.5;
  }
  .season-autumn:before {
    background: #ffb137;
    opacity: 0.5;
  }
}

.expert-calendar {
  display: flex;
  flex-wrap: wrap;
  margin: 0 auto;
  &__cell {
    width: 73px;
    height: 62px;
    border: 1px solid rgba(25, 30, 50, 0.05);
    position: relative;
    display: flex;
    flex-wrap: wrap;
    padding: 10px 12px;
    &.selectable {
      overflow: hidden;
      :after {
        content: "";
        width: 10px;
        height: 10px;
        position: absolute;
        top: -17px;
        right: -19px;
        border-bottom: 10px solid #e62d3b;
        border-left: 10px solid transparent;
        border-top: 10px solid transparent;
        border-right: 10px solid transparent;
        transform: rotate(45deg);
      }
    }
    .value {
      width: 100%;
      text-align: left;
      @include font-mixin(16px, 20px, 400, $cobalt-black, 0.2px);
    }
    .index {
      width: 100%;
      text-align: right;
      @include font-mixin(12px, 17px, 400, $shale-gray, 0.2px);
    }
  }
  .__winter {
    background: #e5edf9;
    &.__spring {
      background: linear-gradient(90deg, #e5edf9 7.53%, #fffbda 100%);
    }
  }
  .__spring {
    background: #fffcdb;
    &.__summer {
      background: linear-gradient(90deg, #fffbda 0.68%, #b7f1e0 100%);
    }
  }
  .__summer {
    background: #b7f1e0;
    &.__autumn {
      background: linear-gradient(90deg, #b7f1e0 0%, #ffefd7 100%);
    }
  }
  .__autumn {
    background: #ffefd7;
    &.__winter {
      background: linear-gradient(90deg, #ffefd7 0%, #e5edf9 100%);
    }
  }
}
::v-deep {
  .units {
    align-self: center;
  }
}
</style>
